;FVID 1.1 by Falcosoft

.586p
FVID SEGMENT PUBLIC USE16
assume cs:FVID,ds:FVID,es:FVID,ss:FVID
org 100h
START:

            mov ax,offset prog
            call show
            mov ax,offset eol
            call show

            mov ax,0F000h ;386+ detect
	    push ax
	    popf
	    pushf
	    pop ax
	    and ah,0F0h
	    sti
	    jz @nosupport

            pushfd       ;cpuid detect
            pop eax
            mov ebx,eax
            btc eax,21
            push eax
            popfd
            pushfd
            pop eax
            cmp eax,ebx
            jz @nosupport

            mov eax,1    ;mtrr detect
            cpuid
            mov eax,12
            bt edx,eax
            jnc @nosupport

	    ;vbe info
            mov ax,4F00h
            mov di, offset vbeinfo
            int 10h
            cmp ah,0
            jnz @nosupport
            xor eax,eax
            mov ax,vbeinfo.TotalMemory
            shl eax,4 ;VESA gives 64k units MTRR expects 4K units
            sub eax,1 ;for MTRR range
	    mov dword ptr [vidmem],eax
            ;end vbe info

            ;mode info
            mov ax,4F01h
            mov cx,101h
            mov di, offset modeinfo
            int 10h
            ;end mode info


            ;start wc

            mov eax,modeinfo.PhysBasePtr
            cmp eax,0
            je @nosupport
            or eax,1
            mov ebx,eax
            mov ecx,8
@seek:      push ecx
            mov ecx,200h
            add ecx, dword ptr [mtrroffset]
            mov dword ptr [pmtrr], ecx
            rdmsr
            add dword ptr[mtrroffset],2
	    cmp eax,ebx
            pop ecx
	    loopne @seek
            mov ecx,dword ptr [pmtrr]
            mov eax,ebx
            mov edx,0

            wrmsr
            lea ecx,[ecx+1]
            mov eax,0FFFFFh
            sub eax,dword ptr [vidmem]
            shl eax,12
            or eax,800h
            mov edx,0000000Fh

            mov si,82h
            mov bl,"0"
            cmp bl,[si]
            mov word ptr [status], offset enable
            jnz @noclear
            mov word ptr [status], offset disable
            and eax,0FFFFF7FFh
@noclear:
            wrmsr

            ;end wc
            mov ax,word ptr [status]
            call show
            jmp @exitp

@nosupport:
            mov ax,offset nosup
            call show


@exitp:     xor eax,eax
            mov ax,4c00h
            int 21h

            show proc
             mov dx,ax
             mov ah,9
             int 21h
             ret
            show endp

ModeInfoBlock struc

ModeAttributes dw ?
WinAAttributes db ?
WinBAttributes db ?
WinGranularity dw ?
WinSize dw ?
WinASegment dw ?
WinBSegment dw ?
WinFuncPtr dd ?
BytesPerScanLine dw ?
XResolution dw ?
YResolution dw ?
XCharSize db ?
YCharSize db ?
NumberOfPlanes db ?
BitsPerPixel db ?
NumberOfBanks db ?
MemoryModel db ?
BankSize db ?
NumberOfImagePages db ?
Reserved1 db 1
RedMaskSize db ?
RedFieldPosition db ?
GreenMaskSize db ?
GreenFieldPosition db ?
BlueMaskSize db ?
BlueFieldPosition db ?
RsvdMaskSize db ?
RsvdFieldPosition db ?
DirectColorModeInfo db ?
PhysBasePtr dd ?
Reserved2 dd 0
Reserved3 dw 0
LinBytesPerScanLine dw ?
BnkNumberOfImagePages db ?
LinNumberOfImagePages db ?
LinRedMaskSize db ?
LinRedFieldPosition db ?
LinGreenMaskSize db ?
LinGreenFieldPosition db ?
LinBlueMaskSize db ?
LinBlueFieldPosition db ?
LinRsvdMaskSize db ?
LinRsvdFieldPosition db ?
MaxPixelClock dd ?
Reserved4 db 189 dup (?)

ModeInfoBlock ends


VbeInfoBlock struc

VbeSignature db 'VESA'
VbeVersion dw 0300h
OemStringPtr dd ?
Capabilities db 4 dup (?)
VideoModePtr dd ?
TotalMemory dw ?
OemSoftwareRev dw ?
OemVendorNamePtr dd ?
OemProductNamePtr dd ?
OemProductRevPtr dd ?
Reserved db 222 dup (?)
OemData db 256 dup (?)

VbeInfoBlock ends

status      dw ?
pmtrr       dd 200h
mtrroffset  dd 0
vidmem  dd ?
prog    db "FVID 1.1 by Falcosoft","$"
enable  db "WC on LFB enabled","$"
disable db "WC on LFB disabled","$"
nosup   db "Hardware does not support Write Combining feature on LFB!","$"
eol     db 10,13,"$"

vbeinfo  VbeInfoBlock <>
modeinfo ModeInfoBlock <>



FVID ENDS
END START